import { World, Commands } from 'mojang-minecraft';

function runCommand(command, dimension) {
  try {
    return { error: false, ...Commands.run(command, World.getDimension(dimension ?? 'overworld')) };
  } catch (error) {
    return { error: true };
  };
};

World.events.beforeChat.subscribe((chatData) => {
  let plName = chatData.sender.name ?? chatData.sender.nameTag;
  
  if (chatData.message === ".emote zombie") {
    runCommand(`playanimation "${plName}" animation.zombie.attack_bare_hand zombie 999999`);
    runCommand(`execute "${plName}" ~ ~ ~ playsound mob.zombie.say @a[r=6]`);
    chatData.cancel = true
  };
  
  if (chatData.message === ".stopemote") {
    chatData.cancel = true;
    runCommand(`playanimation "${plName}" animation.zombie.attack_bare_hand stop 0`)
  };
  
  if (chatData.message === ".emote bored") {
    chatData.cancel = true;
    runCommand(`playanimation "${plName}" animation.react_bored_1`)
  };
  
  if (chatData.message === ".emote vindicator") {
    runCommand(`playanimation "${plName}" animation.vindicator.attack vindicator 999999`);
    runCommand(`execute "${plName}" ~ ~ ~ playsound mob.vindication_illager.idle @a[r=6]`);
    chatData.cancel = true
  };
  
  if (chatData.message === ".emote sit") {
    runCommand(`playanimation "${plName}" animation.player.sit sit 999999`);
    chatData.cancel = true
  };
  
  if (chatData.message === ".emote up-arm") {
    runCommand(`playanimation "${plName}" animation.player.up_arm`);
    chatData.cancel = true
  };
  
  if (chatData.message === ".emote celebrate") {
    runCommand(`playanimation "${plName}" animation.humanoid.celebrating celebrate 999999`);
    chatData.cancel = true
  };
  
  if (chatData.message === ".emote sleep") {
    runCommand(`playanimation "${plName}" animation.player.sleeping sleep 999999`);
    chatData.cancel = true
  };
  
  if (chatData.message === ".emote raised-arms") {
    runCommand(`playanimation "${plName}" animation.player.raised_arms raised-arms 999999`);
    chatData.cancel = true
  };
  
  if (chatData.message === ".emote criminal") {
    runCommand(`playanimation "${plName}" animation.player.criminal criminal 999999`);
    chatData.cancel = true
  };
  
  if (chatData.message === ".emote dab") {
    runCommand(`playanimation "${plName}" animation.player.dab`);
    chatData.cancel = true
  };
  
  if (chatData.message === ".emote facepalm") {
    runCommand(`playanimation "${plName}" animation.player.facepalm`);
    chatData.cancel = true
  };
  
  if (chatData.message === ".emote child") {
    runCommand(`playanimation "${plName}" animation.player.child child 999999`);
    chatData.cancel = true
  };
  
  if (chatData.message === ".emote child-sit") {
    runCommand(`playanimation "${plName}" animation.player.child_sit child-sit 999999`);
    chatData.cancel = true
  };
  
 if (chatData.message === ".emote dinnerbone") {
    runCommand(`playanimation "${plName}" animation.player.dinnerbone dinnerbone 999999`);
    chatData.cancel = true
  };
  
  if (chatData.message === ".emote dead") {
    runCommand(`playanimation "${plName}" animation.player.dead dead 999999`);
    chatData.cancel = true
  };
  
  if (chatData.message === ".emote laugh") {
    runCommand(`playanimation "${plName}" animation.player.laugh`);
    runCommand(`execute "${plName}" ~ ~ ~ playsound emote.laugh @a[r=6]`);
    chatData.cancel = true
  };
  
  if (chatData.message === ".emote") {
    runCommand(`execute "${plName}" ~ ~ ~ function help`);
    chatData.cancel = true
  };
  
});
